package com.logicbig.example;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.event.ActionEvent;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.ThreadLocalRandom;
import java.util.concurrent.atomic.AtomicInteger;

@ManagedBean
@ViewScoped
public class TaskView {
    private AtomicInteger progressInteger = new AtomicInteger();
    private ExecutorService executorService;

    public void startTask(ActionEvent ae) {
        executorService = Executors.newSingleThreadExecutor();
        executorService.execute(this::startLongTask);
    }

    private void startLongTask() {
        progressInteger.set(0);
        for (int i = 0; i < 100; i++) {
            progressInteger.getAndIncrement();
            //simulating long running task
            try {
                Thread.sleep(ThreadLocalRandom.current().nextInt(1, 100));
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        executorService.shutdownNow();
        executorService = null;
    }

    public int getProgress() {
        return progressInteger.get();
    }

    public String getResult() {
        return progressInteger.get() == 100 ? "task done" : "";
    }
}